#include <Keyboard.h>

#define KEY_SPACE 0x20
#define KEY_F 0x66                  

const int trigger1 = 5; // Trigger pin of 1st Sesnor
const int echo1 = 6; // Echo pin of 1st Sesnor
const int trigger2 = 3; // Trigger pin of 2nd Sesnor
const int echo2 = 4; // Echo pin of 2nd Sesnor

void find_distance (int &distL, int &distR)                   
{
	digitalWrite(trigger1, LOW);
	delayMicroseconds(2);
	digitalWrite(trigger1, HIGH);
	delayMicroseconds(10);
	digitalWrite(trigger1, LOW);
    long duration;
    float r;
	duration = pulseIn(echo1, HIGH, 5000);
	r = 3.4 * duration / 2;                      
	distL = r / 100.00;

	digitalWrite(trigger2, LOW);
	delayMicroseconds(2);
	digitalWrite(trigger2, HIGH);
	delayMicroseconds(10);
	digitalWrite(trigger2, LOW);
	duration = pulseIn(echo2, HIGH, 5000);
	r = 3.4 * duration / 2;     
	distR = r / 100.00;
	delay(100);
}


void setup() {
	Serial.begin(9600); 
		
	pinMode(trigger1, OUTPUT); 
	pinMode(echo1, INPUT); 
	pinMode(trigger2, OUTPUT); 
	pinMode(echo2, INPUT); 
}

void calculate_distance(int trigger, int echo, int &dist)
{
	digitalWrite(trigger, LOW);
	delayMicroseconds(2);
	digitalWrite(trigger, HIGH);
	delayMicroseconds(10);
	digitalWrite(trigger, LOW);

	long long time_taken = pulseIn(echo, HIGH);
	dist = time_taken * 0.034 / 2;
	if (dist > 50)
	dist = 50;
}

void loop() {
    int dist;
    int distL, distR;
	calculate_distance(trigger1, echo1, dist);
	distL = dist; // get distance of left sensor

	calculate_distance(trigger2, echo2, dist);
	distR = dist; // get distance of right sensor


	// Pause/play
	if ((distL > 35 && distR > 35) && (distL < 50 && distR < 50)) { // Detect both hands
        Keyboard.press(KEY_SPACE);
        delay(500);
        Keyboard.release(KEY_SPACE);
    }
	calculate_distance(trigger1, echo1, dist);
	distL = dist;

	calculate_distance(trigger2, echo2, dist);
	distR = dist;

	// Volume
	if (distL >= 10 && distL <= 20) {
		delay(150); // Hand Hold Time
		calculate_distance(trigger1, echo1, dist);
		distL = dist;
		if (distL >= 10 && distL <= 20) {
			while(distL <= 40) {
				calculate_distance(trigger1, echo1, dist);
				distL = dist;
				if (distL < 15) { // Hand pushed in 
                    Keyboard.press(KEY_UP_ARROW);
                    delay(500);
                    Keyboard.release(KEY_UP_ARROW);
				}
				if (distL > 20) { // Hand pulled out
                    Keyboard.press(KEY_DOWN_ARROW);
                    delay(500);
                    Keyboard.release(KEY_DOWN_ARROW);
				}
			}
		}
	}

	// Forward/rewind
	if (distR >= 10 && distR <= 20)
	{
		delay(150); //Hand Hold Time
		calculate_distance(trigger2, echo2, dist);
		distR = dist;
		if (distR >= 10 && distR <= 20)
		{
			while(distR <= 40)
			{
				calculate_distance(trigger2, echo2, dist);
				distR = dist;
				if (distR < 15) { //Right hand pushed in
                    Keyboard.press(KEY_LEFT_ARROW);
                    delay(500);
                    Keyboard.release(KEY_LEFT_ARROW);
				}
				if (distR > 20) { //Right hand pulled out
                    Keyboard.press(KEY_RIGHT_ARROW);
                    delay(500);
                    Keyboard.release(KEY_RIGHT_ARROW);
				}
			}
		}
	}

	// Full screen
    unsigned long temp = 0;
	if (distR <= 8 && distR >= 0) { 
        temp = millis();
        while(millis() <= (temp + 300))
        find_distance(distL, distR);																
        Keyboard.press(KEY_F);
        delay(500);
        Keyboard.release(KEY_F);              
    }
	delay(200);
}
